<?php

/**
 * @file
 * Handles the management page for Speed_form_blocks module.
 */

/**
 * Does the 'admin/structure/speed_form_blocks/management' page.
 */
function speed_form_blocks_management() {

  $result = db_query('SELECT bid, block_name, extra, button, 
  message, pre_html, 
  post_html, class 
  from {speed_form_blocks_created}');
  $counter = 0;

  foreach ($result as $block) {

    if ($counter === 0) {

      $form['inline_feedback_main'] = array(
        '#markup' => '<h3>' . t('Speed form block management') . '</h3>',
      );

    }

    $counter++;

    $form[$block->block_name] = array(

      '#type' => 'fieldset',
      '#title' => t("%block_name block (click to expand)", array('%block_name' => $block->block_name)),
      '#collapsible' => TRUE,
      '#collapsed' => TRUE,
      '#tree' => TRUE,

    );

    $form[$block->block_name][$block->block_name . "_blockname"] = array(
      '#type' => 'hidden',
      '#value' => $block->block_name,
    );

    $form[$block->block_name][$block->block_name . "_newname"] = array(
      '#type' => 'machine_name',
      '#title' => t("New name for this block. This block needs to be a machine name"),
      '#default_value' => $block->block_name,
      '#machine_name' => array(

        'exists' => 'speed_form_blocks_management_name_exists',

      ),
    );

    $form[$block->block_name][$block->block_name . "_display"] = array(
      '#markup' => '<strong>' . t('The following are fields used in this form') . '</strong>',
    );

    $data = unserialize($block->extra);
    $size = count($data);

    for ($x = 0; $x < $size; $x++) {

      $form[$block->block_name][$block->block_name . "_extra_" . $x . '_type'] = array(
        '#type' => 'select',
        '#title' => t("Selected type"),
        '#description' => t("The input type (in HTML) for this form element"),
        '#options' => array(
          0 => t('checkbox'),
          1 => t('date'),
          2 => t('text_format'),
          3 => t('textarea'),
          4 => t('textfield'),
        ),
        '#default_value' => $data[$x]['type'],
      );

      $form[$block->block_name][$block->block_name . "_extra_" . $x . '_name'] = array(
        '#type'  => 'textfield',
        '#size'  => 100,
        '#title' => t("Name for this form element"),
        '#default_value' => $data[$x]['name'],
		'#element_validate' => array('_speed_form_blocks_management_element_no_space'),
		'#description' => t("This field can't contain any whitespace."),
		'#required' => TRUE,
      );

      $form[$block->block_name][$block->block_name . "_extra_" . $x . '_desc'] = array(
        '#type'  => 'textfield',
        '#size'  => 100,
        '#title' => t("User prompt for this element"),
        '#default_value' => $data[$x]['desc'],
        '#required' => TRUE,
      );

      $form[$block->block_name][$block->block_name . "_extra_" . $x . '_delete'] = array(
        '#type'  => 'checkbox',
        '#title' => t("Delete this field"),
      );

    }

    /*
     * New fields
     */

    $form[$block->block_name][$block->block_name . "_new"] = array(

      '#type' => 'fieldset',
      '#title' => t("Add more fields (click to expand)"),
      '#collapsible' => TRUE,
      '#collapsed' => TRUE,
      '#tree' => TRUE,

    );

    $form[$block->block_name][$block->block_name . "_new"]['new_type'] = array(
      '#type'  => 'select',
      '#title' => t("Selected type"),
      '#description' => t("The input type (in HTML) you wish to add to this form"),
      '#options' => array(
        0 => t('checkbox'),
        1 => t('date'),
        2 => t('text_format'),
        3 => t('textarea'),
        4 => t('textfield'),
      ),
    );

    $form[$block->block_name][$block->block_name . "_new"]['new_name'] = array(
      '#type'  => 'textfield',
      '#size'  => 100,
      '#title' => t("Name for this form element"),
    );

    $form[$block->block_name][$block->block_name . "_new"]['new_desc'] = array(
      '#type'  => 'textfield',
      '#size'  => 100,
      '#title' => t("User prompt for this element"),
    );

    /*
     * Other fields
     */

    $form[$block->block_name][$block->block_name . "_other"] = array(

      '#type'  => 'fieldset',
      '#title' => t('%block_name Other settings (click to minimise)', array('%block_name' => $block->block_name)),
      '#collapsible' => TRUE,
      '#collapsed' => FALSE,
      '#tree' => TRUE,

    );

    $form[$block->block_name][$block->block_name . "_other"][$block->block_name . "_pre_html"] = array(
      '#type'  => 'textarea',
      '#title' => t("HTML to display before the form"),
      '#default_value' => $block->pre_html,
      '#description' => t("HTML to show before the form"),
    );

    $form[$block->block_name][$block->block_name . "_other"][$block->block_name . "_button"] = array(
      '#type'  => 'textfield',
      '#title' => t("Button label"),
      '#default_value' => $block->button,
      '#description' => t("This text that will appear on the form 'submit' button for this block"),
    );

    $form[$block->block_name][$block->block_name . "_other"][$block->block_name . "_message"] = array(
      '#type'  => 'textarea',
      '#title' => t("Message post submission"),
      '#default_value' => $block->message,
      '#description' => t("This message will appear after a form is submitted"),
    );

    $form[$block->block_name][$block->block_name . "_other"][$block->block_name . "_post_html"] = array(
      '#type'  => 'textarea',
      '#title' => t("HTML to display after the form"),
      '#default_value' => $block->post_html,
      '#description' => "HTML to show after the form",
    );

    $form[$block->block_name][$block->block_name . "_other"][$block->block_name . "_class"] = array(
      '#type'  => 'textfield',
      '#title' => t("CSS class for the form"),
      '#default_value' => $block->class,
      '#description' => "HTML Class for the form",
    );
    
    $form[$block->block_name][$block->block_name . "_delete"] = array(
      '#type'  => 'checkbox',
      '#title' => t("Check this box to delete this block (this will not delete any data received for this block"),
    );
	
	$form[$block->block_name]['delete'] = array(
      '#type' => 'submit',
      '#value' => t('Save'),
      '#submit' => array('speed_form_blocks_management_handler'),
    );

    $form[$block->block_name][$block->block_name . "_bid"] = array(
      '#type'  => 'hidden',
      '#value' => $block->bid,
    );

  }

  if ($counter === 0) {

    $form['inline_feedback_main'] = array(
      '#markup' => '<p>' . t('No blocks have been created yet, please visit block creation') . '</p>',
    );

  }

  return $form;

}

/**
 * Does the submission the management data when saved.
 */
function speed_form_blocks_management_handler($form, &$form_state) {

  foreach ($form_state['values'] as $key => $value) {
  
    if (is_array($value)) {

      if ($form_state['input'][$key][$key . "_delete"] == 1) {

        $num_deleted = db_delete('speed_form_blocks_created')
        ->condition('bid', $form_state['input'][$key][$key . "_bid"])
        ->execute();

        unset($form_state['input'][$key]);

      }

    }

  }

  foreach ($form_state['values'] as $key => $value) {

    if (is_array($value)) {

      if ($value[$key . "_blockname"] != $value[$key . "_newname"]) {

        db_update('speed_form_blocks_created')
          ->condition('bid', $value[$key . "_bid"])
          ->fields(array('block_name' => $value[$key . "_newname"]))
          ->execute();

      }

    }

  }

  $result = db_query('SELECT block_name from {speed_form_blocks_created}');

  foreach ($result as $block) {

    if (isset($form_state['values'][$block->block_name])) {

      $submit = array();
      $data = $form_state['values'][$block->block_name];

      foreach ($data as $setting => $value) {

        if (!is_array($value)) {

          if (strpos($setting, "_extra_") !== FALSE) {

            $information = explode("_", str_replace($block->block_name, "", $setting));
            $submit[$information[2]][$information[3]] = $value;

            if (strpos($setting, "_delete") !== FALSE) {

              if ($value == 1) {

                drupal_set_message(t("Field removed"), 'status');
                unset($submit[$information[2]]);

              }

            }

          }
          else {

            if (strpos($setting, "save") === FALSE && strpos($setting, "delete") === FALSE && strpos($setting, "_blockname") === FALSE && strpos($setting, "_newname") === FALSE && strpos($setting, "_delete") === FALSE && strpos($setting, "_bid") === FALSE) {

              db_update('speed_form_blocks_created')
                ->condition('block_name', $block->block_name)
                ->fields(array(
                  str_replace($block->block_name . "_", "", $setting)
                  => $value))
                ->execute();
            }

          }

        }

        if ($setting == $block->block_name . "_other") {

          foreach ($form_state['values'][$block->block_name][$setting] as $key => $value) {

            db_update('speed_form_blocks_created')
              ->condition('block_name', $block->block_name)
              ->fields(array(
                str_replace($block->block_name . "_", "", $key)
                => $value))
              ->execute();

          }

        }

        if ($setting == $block->block_name . "_new") {

          $new_submit = array();

          foreach ($form_state['values'][$block->block_name][$setting] as $key => $value) {

            if (!empty($value)) {

              $new_submit[str_replace("new_", "", $key)] = $value;

            }

          }

          if (count($new_submit) == 3) {

            drupal_set_message(t("New field Added"), 'status');
            $submit[] = $new_submit;

          }

        }

      }

      $submit = array_values($submit);

      if (drupal_strlen(serialize($submit)) < 500) {

        db_update('speed_form_blocks_created')
          ->condition('block_name', $block->block_name)
          ->fields(array('extra' => serialize($submit)))
          ->execute();

        drupal_set_message(t("Block(s) Updated"), 'status');

      }
      else {

        drupal_set_message(t("Other Settings (button label, post submission message etc.) are too long"), 'error');

      }

    }

  }

}

/**
 * Does the checking to see if a block of this name already exists.
 *
 * @param string $value_to_check
 *   suggested machine name for the block.
 *
 * @return boolean
 *   TRUE is block exists, and FALSE if not.
 */
function speed_form_blocks_management_name_exists($value_to_check) {

  $query = db_query('SELECT n.block_name 
  FROM {speed_form_blocks_created} n 
  WHERE n.block_name = :block_name 
  LIMIT 1',
  array(':block_name' => $value_to_check));

  $exists = $query->fetch();

  if ($exists) {

    drupal_set_message(t("Block name %block_name is already in use. Please choose another name", array("%block_name" => $value_to_check)), 'error');
    return TRUE;

  }

  return FALSE;

}

/**
 * Checks to see if a form name element contains whitespace.
 *
 * @param string $value_to_check
 *   suggested machine name for the block.
 */
function _speed_form_blocks_management_element_no_space($value_to_check) {

  if (strpos($value_to_check['#value']," ") !== FALSE) {

    form_error($value_to_check,t("This cannot contain whitespace"));

  }

}
